=== debian/changelog ===
scipy (1.6.0-2) unstable; urgency=medium

  * Team upload.
  * upload new upstream version to unstable

 -- Drew Parsons <dparsons@debian.org>  Sat, 16 Jan 2021 23:26:56 +1100

scipy (1.6.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Standards-Version: 4.5.1
  * drop debian/python3-scipy.docs: Thanks.txt no longer shipped.
  * update debian/copyright for new features
    - benchmarks/benchmarks/go_benchmark_functions/*.py
      Copyright: 2013 Andrea Gavana <andrea.gavana@gmail.com>
      License: expat
    - scipy/fft/_pocketfft/pocketfft.cxx
      Copyright: 2010-2019 Max-Planck-Society, Martin Reinecke
      2019 Peter Bell. License: BSD-3-clause
    - scipy/fft/_pocketfft/pocketfft_hdronly.h
      Copyright: 2010-2019 Max-Planck-Society, Martin Reinecke
      2019 Peter Bell, 2003,2007-2014 Matteo Frigo,
      Massachusetts Institute of Technology. License: BSD-3-clause
    - scipy/optimize/_highs/*
      Copyright: 2020 ERGO-Code
      License: Expat
    - scipy/sparse/csgraph/_matching.pyx
      Copyright: 1987, A. Volgenant/Amsterdam School of Economics,
      University of Amsterdam. License: BSD-3-clause
    - scipy/_lib/uarray/*
      Copyright: 2018, Quansight-Labs
      License: BSD-3-clause

 -- Drew Parsons <dparsons@debian.org>  Wed, 06 Jan 2021 19:57:43 +1100
