=== debian/tests/control ===
Tests: python3
Depends: build-essential, python3-scipy, python3-pytest, python3-all, python3-all-dev, python3-pil

# short test on all python versions including debug
Tests: python3-smoke
Depends: python3-scipy, python3-scipy-dbg, python3-pytest, python3-all, python3-all-dbg

#needs root for update-alternatives, build-essential for libc6-dev (ctype libm.so)
Tests: openblas
Restrictions: needs-root
Depends: build-essential, python3-scipy, python3-pytest, python3, libopenblas0

#needs root for update-alternatives, build-essential for libc6-dev (ctype libm.so)
Tests: atlas
Restrictions: needs-root
Depends: build-essential, python3-scipy, python3-pytest, python3, libatlas3-base

#needs root for update-alternatives, build-essential for libc6-dev (ctype libm.so)
Tests: blis
Restrictions: needs-root
Depends: build-essential, python3-scipy, python3-pytest, python3, libblis3
